USE [TP_DATABASE_NAME]
GO
/****** Object:  StoredProcedure [dbo].[archive_garbageCollectByTaskId]    Script Date: 12/05/2011 14:23:42 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE
[dbo].[archive_garbageCollectByTaskId] 
@task_id VARCHAR(255)
AS
	DECLARE @workingId VARCHAR(255);

	DECLARE tasksCoursor CURSOR LOCAL FOR
		SELECT tasksessionid 
		FROM archive_tasksession12_5 
		WHERE initiatorid = @task_id AND tasksessionid != initiatorid;

	DECLARE eventCoursor CURSOR LOCAL FOR
		SELECT eventid
		FROM archive_event12_5
		WHERE tasksessionid = @task_id;
BEGIN

	PRINT 'GC task ID ' + @task_id;
	
	OPEN tasksCoursor;
	WHILE 1 = 1 
	BEGIN
		FETCH NEXT FROM tasksCoursor INTO @workingId;
		IF @@FETCH_STATUS <> 0 BREAK;  -- exit loop if condition is true
		EXEC archive_garbageCollectByTaskId @workingId;
	END
	CLOSE tasksCoursor;
	DEALLOCATE tasksCoursor;

	OPEN eventCoursor;
	WHILE 1 = 1 
	BEGIN 
		FETCH NEXT FROM eventCoursor INTO @workingId;
		IF @@FETCH_STATUS <> 0 BREAK;  -- exit loop if condition is true
		EXEC archive_garbageCollectByEventId @workingId;
	END
	CLOSE eventCoursor;
	DEALLOCATE eventCoursor;
	
	EXEC archive_garbageCollectById @task_id;
	
	DELETE FROM archive_tasksession12_5
	WHERE tasksessionid = @task_id;
	

END --archive_garbageCollectByTaskId